#include <cstdio>
#include <vector>
#include <cmath>
using namespace std;

struct p {
    double x, y;
    p( double a = 0, double b = 0 ) : x(a), y(b) {}
};

vector<p> data;
long long N, R;
int d;

inline double odl( p A, int id ) {
    return (A.x - data[id].x) * (A.x - data[id].x) + (A.y - data[id].y) * (A.y - data[id].y);
}

vector<p> licz_srodki(p a, p b)
{
    vector<p> res;

    if(a.y > b.y)
        swap(a, b);

    double xn1 = a.x , yn1 = a.y, xn2= b.x, yn2 = a.y;

    if(a.y == b.y)
    {
        vector<p> res;

        res.push_back(p( (a.x+b.x)/2, sqrt(d*d-a.y*a.y)));
        res.push_back(p( (a.x+b.x)/2, -sqrt(d*d-a.y*a.y)));
        return res;
    }

    double al = atan( (double)abs(a.x-b.x)/abs(a.y - b.y));

    if(a.x >= b.x)
        al += M_PI/2;

    printf("alfa %lf\n", al);

    xn1 = a.x*cos(-al)-a.y*sin(-al);
    yn1 = a.x*sin(-al)+a.y*cos(-al);
    xn2 = b.x*cos(-al)-b.y*sin(-al);
    yn2 = b.x*sin(-al)+b.y*cos(-al);
    printf("%lf %lf %lf %lf\n", xn1, yn1, xn2, yn2);

    double nowyx = (xn1+xn2)/2;
    double nowyya = sqrt(d*d-nowyx*nowyx); 
    double nowyyb = -sqrt(d*d-nowyx*nowyx);

    double nx1, ny1, nx2, ny2;

    nx1 = nowyx*cos(al)-nowyya*sin(al);
    ny1 = nowyx*sin(al)+nowyyb*sin(al);

    nx2 = nowyx*cos(al)-nowyya*sin(al);
    ny2 = nowyx*sin(al)+nowyyb*sin(al);

    res.push_back(p(nx1, ny1));
    res.push_back(p(nx2, ny1));

    printf("licze %lf %lf %lf %lf\n", a.x, a.y, b.x, b.y);
    printf("%.2lf %.2lf\n", nx1, ny1);
    printf("%.2lf %.2lf\n", nx2, ny2);

    return res;
}

int fun() {
    scanf("%lld %lld", &N, &R);

    if ( N == 0 and R == 0 )
        return 1;

    d = R;
    int r = R * 2;
    R *= R;

    data.clear();
    for ( int i = 0; i < N; i++ ) {
        long long x, y;
        scanf("%lld %lld", &x, &y);
        data.push_back( p(x, y) );
    }

    int res = 0;
    for ( int i = 0; i < N; i++ ) {
        for ( int j = i+1; j < N; j++ ) {
            if ( odl( data[i], j ) > (double)r )
                continue;

//
            vector<p> XX = licz_srodki(data[i], data[j]);
//

            p srodek1 = XX[0]; // FIXME
            p srodek2 = XX[1]; // FIXME

            int lres = 0;
            for ( int k = 0; k < N; k++ ) {
                if ( odl( srodek1, k ) > (double)R ) {
                    lres++;
                    if ( N - lres < res )
                        break;
                }
            }

            res = max(res, lres);

            lres = 0;
            for ( int k = 0; k < N; k++ ) {
                if ( odl( srodek2, k ) > (double)R ) {
                    lres++;
                    if ( N - lres < res )
                        break;
                }
            }

            res = max(res, lres);
        }
    }

    printf("It is possible to cover %d points.\n", res);
    return 0;
}

int main() {
    while ( ! fun() ) ;
    return 0;
}
