#include <cstdio>
#include <vector>
#include <cmath>
using namespace std;

struct p {
    long long x, y;
    p( long long a = 0, long long b = 0 ) : x(a), y(b) {}
};

vector<p> data;
long long N, R;

inline long long odl( p A, int id ) {
    return (A.x - data[id].x) * (A.x - data[id].x) + (A.y - data[id].y) * (A.y - data[id].y);
}

vector<p> licz_srodki(p a, p b)
{
    vector<p> res;

    if(a.y > b.y)
        swap(a, b);

    double al = atan( (double)(a.x-b.x)/(a.y - b.y));

    if(a.x > b.x)
        al += M_PI/2;

    double xn1 = a.x*cos(-al)-a.y*sin(-al);
    double yn1 = a.x*sin(-al)+a.y*sin(-al);

    double xn2 = b.x*cos(-al)-b.y*sin(-al);
    double yn2 = b.x*sin(-al)+b.y*sin(-al);

    printf("%lf %lf %lf %lf\n", xn1, xn2, yn1, yn2);


    double nowyy = (yn1+yn2)/2;
    double nowyxa = sqrt(d*d-nowyy*nowyy); 
    double nowyxb = sqrt(d*d-nowyy*nowyy);

    double nx1, ny1, nx2;

    nx1 = nowyxa*cos(al)-nowyy*sin(al);
    ny1 = nowyxa*sin(al)+nowyy*sin(al);

    nx2 = nowyxb*cos(al)-nowyy*sin(al);

    res.push_back(p(nx1, ny1));
    res.push_back(p(nx2, ny1));
    return res;
}

int fun() {
    scanf("%lld %lld", &N, &R);

    if ( N == 0 and R == 0 )
        return 1;

    int r = R * 2;
    R *= R;

    data.clear();
    for ( int i = 0; i < N; i++ ) {
        long long x, y;
        scanf("%lld %lld", &x, &y);
        data.push_back( p(x, y) );
    }

    int res = 0;
    for ( int i = 0; i < N; i++ ) {
        for ( int j = i+1; j < N; j++ ) {
            if ( odl( data[i], j ) > r )
                continue;

//
            licz_srodki(data[i], data[j]);
//

            p srodek1(0, 0); // FIXME
            p srodek2(0, 0); // FIXME

            int lres = 0;
            for ( int k = 0; k < N; k++ ) {
                if ( odl( srodek1, k ) > R ) {
                    lres++;
                    if ( N - lres < res )
                        break;
                }
            }

            res = max(res, lres);

            lres = 0;
            for ( int k = 0; k < N; k++ ) {
                if ( odl( srodek2, k ) > R ) {
                    lres++;
                    if ( N - lres < res )
                        break;
                }
            }

            res = max(res, lres);
        }
    }

    printf("It is possible to cover %d points.\n", res);
    return 0;
}

int main() {
    while ( ! fun() ) ;
    return 0;
}
